//+------------------------------------------------------------------+
//|                       double dynamic zone williams percent range |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1  clrLimeGreen
#property indicator_color2  clrRed
#property indicator_color3  clrLimeGreen
#property indicator_color4  clrRed
#property indicator_color5  clrGold
#property indicator_color6  clrDeepSkyBlue
#property indicator_width3  2
#property indicator_width4  2
#property indicator_width6  3
#property indicator_style1  STYLE_DOT
#property indicator_style2  STYLE_DOT
#property indicator_style5  STYLE_DASH
#property strict


//
//
//
//
//

#import "dynamicZone.dll"
   double dzBuy(double& sourceArray[],double initValue, int lookBack, int bars, int i);
   double dzSell(double& sourceArray[],double initValue, int lookBack, int bars, int i);
#import

//
//
//
//
//

extern ENUM_TIMEFRAMES TimeFrame               = PERIOD_CURRENT; // Time frame to use
extern int             HLR_Range               = 50;             // HLR range
extern int             Length                  = 25;             // OMA period
extern double          Speed                   = 8;              // OMA speed
extern bool            Adaptive                = true;           // OMA should be adaptive?
extern int             DzLookBackBars          = 70;             // Dynamic zones lookback bars
extern double          DzStartBuyProbability1  = 0.20;           // Dynamic zones buy probability 1
extern double          DzStartSellProbability1 = 0.20;           // Dynamic zones sell probability 2
extern double          DzStartBuyProbability2  = 0.06;           // Dynamic zones buy probability 2
extern double          DzStartSellProbability2 = 0.06;           // Dynamic zones sell probability 2
extern bool            Interpolate             = true;           // Interpolate in multi time frame mode?

//
//
//
//
//

double HLR_Buffer[];
double bli1[];
double sli1[];
double bli2[];
double sli2[];
double slic[];

string IndicatorFileName;
bool   returninBars;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,bli1);
   SetIndexBuffer(1,sli1);
   SetIndexBuffer(2,bli2);
   SetIndexBuffer(3,sli2);
   SetIndexBuffer(4,slic);
   SetIndexBuffer(5,HLR_Buffer);
   
   Length = MathMax(Length,   1);
   Speed  = MathMax(Speed ,-1.5);

   //
   //
   //
   //
   //
   
         IndicatorFileName = WindowExpertName();
         returninBars      = (TimeFrame==-99);
         TimeFrame         = MathMax(TimeFrame,_Period);
   string shortName = "Dynamic zone Range_osc on oma "+timeFrameToString(TimeFrame)+" ("+(string)HLR_Range+")";
   IndicatorShortName(shortName);
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------


int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returninBars)  { bli1[0] = limit+1; return(0); }
         
   //
   //
   //
   //
   //         
   if (TimeFrame==_Period)
   {  
      for(int i=limit; i>=0; i--)
      {
         double hhv  = iOma(High[iHighest(NULL, 0, MODE_HIGH, HLR_Range, i)],Length,Speed,Adaptive,i,0);
         double llv  = iOma(Low[iLowest(NULL, 0,   MODE_LOW,  HLR_Range, i)],Length,Speed,Adaptive,i,1);
         double m_pr = iOma((High[i] + Low[i]) / 2.0,                        Length,Speed,Adaptive,i,2);
         
         HLR_Buffer[i] = 100.0 * (m_pr - llv) / (hhv - llv); 
               bli1[i] = dzBuy (HLR_Buffer, DzStartBuyProbability1,  DzLookBackBars, Bars, i);
               sli1[i] = dzSell(HLR_Buffer, DzStartSellProbability1, DzLookBackBars, Bars, i);
               bli2[i] = dzBuy (HLR_Buffer, DzStartBuyProbability2,  DzLookBackBars, Bars, i);
               sli2[i] = dzSell(HLR_Buffer, DzStartSellProbability2, DzLookBackBars, Bars, i);
               slic[i] = dzSell(HLR_Buffer, 0.5                    , DzLookBackBars, Bars, i);
         }
         return(0);
      }

   //
   //
   //
   //
   //
   
   limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,IndicatorFileName,-99,0,0)*TimeFrame/Period()));
   for(int i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
      HLR_Buffer[i] = iCustom(NULL,TimeFrame,IndicatorFileName,PERIOD_CURRENT,HLR_Range,Length,Speed,Adaptive,DzLookBackBars,DzStartBuyProbability1,DzStartSellProbability1,DzStartBuyProbability2,DzStartSellProbability2,5,y);
      bli1[i]       = iCustom(NULL,TimeFrame,IndicatorFileName,PERIOD_CURRENT,HLR_Range,Length,Speed,Adaptive,DzLookBackBars,DzStartBuyProbability1,DzStartSellProbability1,DzStartBuyProbability2,DzStartSellProbability2,0,y);
      sli1[i]       = iCustom(NULL,TimeFrame,IndicatorFileName,PERIOD_CURRENT,HLR_Range,Length,Speed,Adaptive,DzLookBackBars,DzStartBuyProbability1,DzStartSellProbability1,DzStartBuyProbability2,DzStartSellProbability2,1,y);
      bli2[i]       = iCustom(NULL,TimeFrame,IndicatorFileName,PERIOD_CURRENT,HLR_Range,Length,Speed,Adaptive,DzLookBackBars,DzStartBuyProbability1,DzStartSellProbability1,DzStartBuyProbability2,DzStartSellProbability2,2,y);
      sli2[i]       = iCustom(NULL,TimeFrame,IndicatorFileName,PERIOD_CURRENT,HLR_Range,Length,Speed,Adaptive,DzLookBackBars,DzStartBuyProbability1,DzStartSellProbability1,DzStartBuyProbability2,DzStartSellProbability2,3,y);
      slic[i]       = iCustom(NULL,TimeFrame,IndicatorFileName,PERIOD_CURRENT,HLR_Range,Length,Speed,Adaptive,DzLookBackBars,DzStartBuyProbability1,DzStartSellProbability1,DzStartBuyProbability2,DzStartSellProbability2,4,y);
      
      if (!Interpolate || (i>0 && y==iBarShift(NULL,TimeFrame,Time[i-1]))) continue;

         //
         //
         //
         //
         //

         int n,j; datetime time = iTime(NULL,TimeFrame,y);
              for(n = 1; (i+n)<Bars && Time[i+n] >= time; n++) continue;	
              for(j = 1; j<n && (i+n)<Bars && (i+j)<Bars; j++)
              {
                  HLR_Buffer[i+j] = HLR_Buffer[i] + (HLR_Buffer[i+n] - HLR_Buffer[i])*j/n;
                  bli1[i+j]       = bli1[i]       + (bli1[i+n]       - bli1[i]      )*j/n;
                  bli2[i+j]       = bli2[i]       + (bli2[i+n]       - bli2[i]      )*j/n;
                  sli1[i+j]       = sli1[i]       + (sli1[i+n]       - sli1[i]      )*j/n;
                  sli2[i+j]       = sli2[i]       + (sli2[i+n]       - sli2[i]      )*j/n;
                  slic[i+j]       = slic[i]       + (slic[i+n]       - slic[i]      )*j/n;
               }
   }      
   return(0);
}

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

#define omaInstances 3
double workOma[][omaInstances*7];
#define F01 0
#define F02 1
#define F03 2
#define F04 3
#define F05 4
#define F06 5
#define prc 6

//
//
//
//
//

double iOma(double price, double averagePeriod, double constant, bool adaptive, int r, int instanceNo=0)
{
   if (averagePeriod <=1) return(price);
   if (ArrayRange(workOma,0) != Bars) ArrayResize(workOma,Bars); r=Bars-r-1; instanceNo *=7;
   if (r<=1) 
   {
      for (int i=0; i<6; i++) workOma[r][i  +instanceNo] = 0;
                              workOma[r][prc+instanceNo] = price;
                              return(price);
   }      
   double f01=workOma[r-1][F01+instanceNo];  double f02=workOma[r-1][F02+instanceNo];
   double f03=workOma[r-1][F03+instanceNo];  double f04=workOma[r-1][F04+instanceNo];
   double f05=workOma[r-1][F05+instanceNo];  double f06=workOma[r-1][F06+instanceNo];

   //
   //
   //
   //
   //

      if (adaptive && (averagePeriod > 1))
      {
         double minPeriod = MathMin(averagePeriod,r)/2.0;
         double maxPeriod = MathMin(minPeriod*5.0,r);
         int    endPeriod = (int)MathCeil(maxPeriod);
         double tsignal   = MathAbs((price-workOma[r-endPeriod][prc+instanceNo]));
         double noise     = 0.00000000001;

            for(int i=1; i<endPeriod && (r-i)>=0; i++) noise=noise+MathAbs(price-workOma[r-i][prc+instanceNo]);

         averagePeriod = ((tsignal/noise)*(maxPeriod-minPeriod))+minPeriod;
      }
      
      //
      //
      //
      //
      //
      
      double Kg = (2.0+constant)/(1.0+constant+averagePeriod);
      double Hg = 1.0-Kg;

      f01 = Kg * price + Hg * f01; f02 = Kg * f01 + Hg * f02; double v01 = 1.5 * f01 - 0.5 * f02;
      f03 = Kg * v01   + Hg * f03; f04 = Kg * f03 + Hg * f04; double v02 = 1.5 * f03 - 0.5 * f04;
      f05 = Kg * v02   + Hg * f05; f06 = Kg * f05 + Hg * f06; double v03 = 1.5 * f05 - 0.5 * f06;

   //
   //
   //
   //
   //

   workOma[r][F01+instanceNo] = f01;  workOma[r][F02+instanceNo] = f02;
   workOma[r][F03+instanceNo] = f03;  workOma[r][F04+instanceNo] = f04;
   workOma[r][F05+instanceNo] = f05;  workOma[r][F06+instanceNo] = f06;
   workOma[r][prc+instanceNo] = price;
   return(v03);
}

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}